# First parameter space investigation.
#Airbridge structure, after first succesful construction of air bridges using previous script
#previous airbridges have spoon like base. Will try to correct this by adding clearance to via.
#model  for testing dose
require_relative 'SK_library'

app = RBA::Application.instance
mw = app.main_window

#  create a new layout 
mw.create_layout( 0 )
view = mw.current_view

layout = view.cellview( 0 ).layout 

linfo = RBA::LayerInfo.new ("ALUM")
alum_layer = layout.insert_layer( linfo )

linfo = RBA::LayerInfo.new ("MARKER")
marker_layer = layout.insert_layer( linfo )

layout.dbu = 0.001
chip_length=6200000

cell1 = layout.create_cell("TOP")

saw_cell=layout.create_cell("SAW")
saw_cell.shapes(alum_layer).insert(RBA::Box::new(-40000,0,0,500000))
saw_cell.shapes(alum_layer).insert(RBA::Box::new(-40000,-40000,500000,0))
saw_cell.shapes(alum_layer).insert(RBA::Box::new(chip_length,chip_length,chip_length-500000,chip_length+40000))
saw_cell.shapes(alum_layer).insert(RBA::Box::new(chip_length,chip_length+40000,chip_length+40000,chip_length-500000))

cell1.insert(saw_cell.ref)

linfo = RBA::LayerInfo.new ("SiO")
sio2_layer = layout.insert_layer( linfo )

x_shift=300000
#for n in 0..10

# will try 20um wide silicon support, 30um long
# SiO2 will be 200nm thick, probably need Al to be thicker for continuity
#x_shift+=100000

support_cell = layout.create_cell("SUPPORT")
support_cell.shapes(sio2_layer).insert(RBA::Box::new(-15000,-10000,15000,10000))
supp_ref=support_cell.ref
supp_ref.a=RBA::Point::new(100000,0)
supp_ref.b=RBA::Point::new(0,100000)
supp_ref.cell_index=support_cell.cell_index
supp_ref.trans=RBA::Trans::new(x_shift,600000)
supp_ref.na=50
supp_ref.nb=50
cell1.insert(supp_ref)


bridge_cell = layout.create_cell("Bridge")

for x in 0..49
for y in 0..49
bridge_cell.shapes(alum_layer).insert(RBA::Box::new(100000*x-15000-x*300,100000*y-6000-y*200,100000*x+15000+x*300,100000*y+6000+y*200))
end
end

bridge_ref=bridge_cell.ref
bridge_ref.trans=RBA::Trans::new(x_shift,600000)
cell1.insert(bridge_ref)

marker_width=20000
marker_length=200000
offsetM=200000
marker_cell= marker(marker_width, marker_length, "MARKER",marker_layer,layout)
marker_ref=marker_cell.ref
marker_ref.na=2
marker_ref.nb=2
marker_ref.trans=RBA::Trans::new(0,offsetM,offsetM)
marker_ref.a=RBA::Point::new(0,chip_length-offsetM-1.2*marker_length - marker_width)
marker_ref.b=RBA::Point::new(chip_length-offsetM-1.2*marker_length - marker_width,0)
cell1.insert(marker_ref)


cell1_ref=cell1.ref
cell1_ref.na=2
cell1_ref.nb=2
cell1_ref.a=RBA::Point::new(chip_length+80000,0)
cell1_ref.b=RBA::Point::new(0,chip_length+80000)

topcell = layout.create_cell("TOPARRAY")
topcell.insert(cell1_ref)

view.select_cell(topcell.cell_index, 0)
view.show_all_cells
#layout.delete_layer(metal_layer)
view.add_missing_layers
